]> pd.if.org Git - zpackage/blobdiff - zpm-install
let newpackage set additional fields
[zpackage] / zpm-install
index 29d8c5d2fc270f0299bc5ecfcbbd46b280c405e1..0a7cf3ed2a8335fe2d2ebede5c095ad264255fca 100755 (executable)
@@ -6,9 +6,16 @@ warn() {
 
 die() {
        echo $* 1>&2
+       zpm log -i -a 'aborting install' -t "$pkgid" "$*"
        exit 1
 }
 
+changeall() {
+       for pkgid in $(zpm list -s $1); do
+               zpm pkg $pkgid status=$2
+       done
+}
+
 dryrun=0
 verbose=0
 runscripts=1
@@ -16,16 +23,20 @@ runconfigure=1
 absorb=0
 overwrite=0
 syncopts=''
+installall=0
+mergefiles=0
 
 # zpm-install [-SCn] [ -d localdb ] [ -f pkgfile ] [ -R installroot ] pkgstr ...
-while getopts f:d:R:nSCvAO opt; do
+while getopts f:d:R:nSCvAOaF opt; do
        case $opt in
                f) pkgfile="$OPTARG" ;;
+               F) mergefiles=1 ;;
                d) localdb="$OPTARG" ;;
                R) rootdir="$OPTARG" ;;
                S) runscripts=0 ;;
                C) runconfigure=0 ;;
                A) absorb=1; syncopts="${syncopts} -A" ;;
+               a) installall=1; ;;
                O) overwrite=1; syncopts="${syncopts} -O" ;;
                n) dryrun=1 ;;
                v) verbose=1 ;;
@@ -34,60 +45,32 @@ while getopts f:d:R:nSCvAO opt; do
 done
 shift $(( OPTIND - 1))
 
-pkgid=$1
-
-if [ -z "$pkgid" ]; then
-       die "must specify pkgid"
+if [ -z "$1" ]; then
+       installall=1
 fi
 
-eval "$(zpm parse -E $pkgid)"
-
 if [ -z "$pkgfile" ]; then
        pkgfile=$ZPM_PACKAGE_FILE
 fi
 
-# cases R = full package id, F = specified package file
-
-# immediate error
-# -- 00 error, must specify something
-if [ -z "$release" ] && [ -z "$pkgfile" ]; then
-       die must specify package file or complete package id
-fi
-
-# TODO look in package file
-# -F 01 error, wouldn't know which pkgid to create, could derive from file?
-if [ -z "$release" ]; then
-       # must have package file, or would have died above
-       pkgid=$(zpm findpkg -f $pkgfile $pkgid)
-       if [ -n "$pkgid" ]; then
-               eval "$(zpm parse -E $pkgid)"
-       fi
-fi
-
-if [ -z "$pkgid" ]; then
-       die "$0 can't figure out a package id"
+if [ $installall -eq 1 ]; then
+       pkglist="$(zpm list -f $pkgfile)"
+else
+       pkglist=$(zpm findpkg -f $pkgfile "$1")
 fi
 
-# set file from pkgid
-# R- 10 set file from pkgid, create in file, error if no file
-if [ -z "$pkgfile" ]; then
-       pkgfile="$pkgid.zpm"
+if [ $verbose -gt 0 ]; then
+       echo $pkglist
 fi
 
-# will now be one of these
-# RF 11 create package in file, error if file doesn't exist
-if [ ! -f "$pkgfile" ]; then
-       die $pkgfile does not exist
+if [ -z "$pkglist" ]; then
+       die "$0 no packages specified for install"
 fi
 
 if [ "$idempotent" = 1 ]; then
        idempotent='or ignore'
 fi
 
-package=$(zpm quote "$name")
-pkgver=$(zpm quote "$version")
-pkgrel=$(zpm quote "$release")
-
 if [ -n "$rootdir" ]; then
        : rootdir=${rootdir%%/}
 fi
@@ -127,7 +110,7 @@ if [ $var -gt 0 ]; then
        zpm list -v -f $localdb -s installing 
        die "already ($localdb) installing $var package(s)"
 fi
-# check if we're installing something already
+# check if we're removing something already
 var=$(zpm list -f $localdb -s removing | wc -l)
 if [ $var -gt 0 ]; then
        zpm list -v -f $localdb -s removing 
@@ -144,32 +127,26 @@ if [ -n "$rootdir" ]; then
        export ZPM_ROOT_DIR
 fi
 
-# TODO mark already installed packages as updating?
-for pkgstr in "$@"; do
-       pkgid=$(zpm findpkg -f $pkgfile $pkgstr)
-       if [ $? -ne 0 ]; then
-               # TODO log
-               die "can't find package $pkgstr in $pkgfile"
-       fi
-
+for pkgid in $pkglist; do
        curstatus=$(zpm pkg $pkgid status)
        if [ "$curstatus" = 'installed' ]; then
                die "$pkgid already installed"
        fi
 
-       eval $(zpm parse -E $pkgid)
-
-       #zpm list -v
+       package=$(zpm parse -n $pkgid)
        current=$(zpm list -s installed "$package")
        
        if [ $runscripts -gt 0 ]; then
                # TODO run pre-upgrade script if needed
                # zpm runscript -p pre-upgrade $current $pkgid
-               zpm runscript -f $pkgfile -p pre-install $pkgid $current
+               zpm script -f $pkgfile -p pre-install $pkgid $current
                if [ $? -ne 0 ]; then
-                       # TODO log
                        die "pre-install script for $pkgid failed"
                fi
+       else
+               if zpm script -f $pkgfile -Fql -p pre-install $pkgid; then
+                       zpm note -e -p $pkgid -m 'pre-install script not run'
+               fi
        fi
 
        # remove the package if it exists.  can't be in an installed
@@ -182,35 +159,78 @@ for pkgstr in "$@"; do
        # only merge if localdb and pkgfile are different
        if [ "$pkgfile" != "$ZPMDB" ]; then
                zpm rmpackage $pkgid
-               zpm merge -f $pkgfile -s installing $pkgid
+               if [ $verbose -gt 0 ]; then
+                       echo merging $pkgid
+               fi
+               if [ $mergefiles -eq 1 ]; then
+                       zpm merge -u -F -f $pkgfile -s installing $pkgid
+               else
+                       zpm merge -u -f $pkgfile -s installing $pkgid
+               fi
                if [ $? -ne 0 ]; then
-                       # TODO log
                        die "merging $pkgid failed"
                fi
+       else
+               zpm pkg $pkgid status=installing
        fi
-       # TODO but need to mark as installing if not merged
 
-       #zpm shell $ZPMDB 'select * from install_status' 1>&2
-       if [ $dryrun -gt 0 ]; then
-               #zpm list -v
-               #zpm shell $ZPMDB 'select * from install_status'
-               zpm syncfs $syncopts -nv -f $pkgfile
-               zpm pkg $pkgid status=dryrun
-               continue
-       fi
+       zpm shell "$ZPMDB" "update packages set status='updating' where status='installed' and package in (select package from packages where status = 'installing')"
+done
 
-       if [ $verbose -gt 0 ]; then
-               syncopts="${syncopts} -v"
-       fi
+# do the sync
 
-       zpm syncfs $syncopts -f $pkgfile
+#zpm shell $ZPMDB 'select * from install_status' 1>&2
+if [ $dryrun -gt 0 ]; then
+       syncopts="$syncopts -n"
+fi
 
-       if [ $? -ne 0 ]; then
-               die 'zpm-syncfs failed';
+if [ $verbose -gt 0 ]; then
+       syncopts="$syncopts -v"
+fi
+
+if [ "$pkgfile" != "$ZPMDB" ]; then
+       syncopts="$syncopts -f $pkgfile"
+fi
+
+#zpm shell $ZPMDB 'select * from syncinfo'
+#zpm list -v
+zpm syncfs $syncopts
+
+syncrv=$?
+
+if [ $dryrun -gt 0 ]; then
+       for pkgid in $pkglist; do
+               zpm pkg $pkgid status=dryrun
+       done
+fi
+
+if [ $syncrv -ne 0 ]; then
+       zpm pkg $pkgid status=failed
+       die 'zpm-syncfs failed';
+fi
+
+if [ $(id -u) -eq 0 ]; then
+       if [ ! -d $rootdir/etc ]; then
+               warn "no etc directory in $rootdir, skipping ldconfig"
+       elif [ -f $rootdir/sbin/ldconfig ]; then
+               $rootdir/sbin/ldconfig -r ${rootdir:-/}
+       elif [ -f /sbin/ldconfig ]; then
+               /sbin/ldconfig -r ${rootdir:-/}
+       else
+               true
        fi
+fi
 
+for pkgid in $pkglist; do
+       package=$(zpm parse -n $pkgid)
+       current=$(zpm list -s updating "$package")
+       
        if [ $runscripts -gt 0 ]; then
-               zpm runscript -f $pkgfile -p post-install $pkgid $current
+               zpm script -p post-install $pkgid $current
+       else
+               if zpm script -Fql -p post-install $pkgid; then
+                       zpm note -e -p $pkgid -m 'post-install script not run'
+               fi
        fi
 
        if [ -n "$current" ]; then
@@ -219,21 +239,16 @@ for pkgstr in "$@"; do
                zpm pkg $pkgid status=installed
        fi
 
-       if [ $(id -u) -eq 0 ]; then
-               if [ ! -d $rootdir/etc ]; then
-                       warn "no etc directory in $rootdir, skipping ldconfig"
-               elif [ -f $rootdir/sbin/ldconfig ]; then
-                       $rootdir/sbin/ldconfig -r ${rootdir:-/}
-               elif [ -f /sbin/ldconfig ]; then
-                       /sbin/ldconfig -r ${rootdir:-/}
-               else
-                       true
-               fi
-       fi
-
        # TODO skip configure if not on a terminal, regardless of settings
        # TODO will need force option
        if [ $runconfigure -gt 0 ]; then
-               zpm runscript -f $pkgfile -p configure $pkgid $current
+               zpm script -p configure $pkgid
+       else
+               if zpm script -Fql -p configure $pkgid; then
+                       zpm note -e -p $pkgid -m 'configure script not run'
+               fi
        fi
+
 done
+
+changeall updating updated